package com.jiuqi.sql.impl;

import java.io.OutputStream;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;

public class DBaseFileTail
{
    private List strValueList;
    private static final String CHARSET = "GBK";
    
    public DBaseFileTail() {
        this.strValueList = new ArrayList();
    }
    
    public void add(final String value) {
        this.strValueList.add(value);
    }
    
    public String get(final int index) {
        return this.strValueList.get(index);
    }
    
    public int size() {
        return this.strValueList.size();
    }
    
    public void readFromStream(final InputStream stream) throws IOException {
        while (stream.available() > 1) {
            final int length = RW.readInt(stream);
            final byte[] data = new byte[length];
            stream.read(data, 0, length);
            try {
                final String value = new String(data, "GBK");
                this.strValueList.add(value);
            }
            catch (final UnsupportedEncodingException e) {
                e.printStackTrace();
            }
        }
    }
    
    public void writeToStream(final OutputStream stream) throws IOException {
        for (int size = this.strValueList.size(), i = 0; i < size; ++i) {
            final String value = this.strValueList.get(i);
            try {
                final byte[] b = value.getBytes("GBK");
                RW.writeInt(stream, b.length);
                stream.write(b);
            }
            catch (final UnsupportedEncodingException e) {
                e.printStackTrace();
                RW.writeInt(stream, 0);
            }
        }
    }
}
